
/***
 * UDP client code
 * Copyright (C) 2011-2016 Knut R Leer (krleer@gmail.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <sys/socket.h>
#include <linux/un.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "udpconv.h"

int udpconv(char *ipadtxt, uint16_t portno, char *cmd, 
	char *repl, size_t replmax, int *ee) 
{
	/* transmission */ 
	struct sockaddr_in A_tx; 
	int ssc;

	/* Reception */
	struct sockaddr_in A_rx; 
	socklen_t len_rx;
	int rxc;

	int s;

	memset(&A_tx, 0, sizeof(struct sockaddr_in));
	A_tx.sin_family = AF_INET;
	A_tx.sin_port = htons(portno);
	A_tx.sin_addr.s_addr = inet_addr(ipadtxt); 

	s = socket(PF_INET, SOCK_DGRAM, 0); 

	// printf("Socket = %d\n", s); 

	ssc = sendto(s, cmd, strlen(cmd), 0, (struct sockaddr *) &A_tx, sizeof(struct sockaddr_in) ); 
	if(ssc == -1) 
	{
		*ee = errno;
		return(-1);
	}

	// printf("sent count = %d\n", ssc); 

	memset(repl, 0, replmax); 
	memset(&A_rx, 0, sizeof(struct sockaddr_in));
	len_rx = sizeof(struct sockaddr_in); 
	errno = 0; 

	rxc = recvfrom(s, repl, replmax, 0, (struct sockaddr *) &A_rx, &len_rx);
	*ee = errno;

	// printf("Received count = %d E = %d (%s)\n", rxc, ee, strerror(ee)); 

	close(s);

	// printf("sent %s received %s (%d)\n", cmd, repl, rxc); 

	return(rxc);
}



